<?php
namespace Teknisa\COZ\Controllers;

use Zeedhi\Framework\Report\ReportService;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO;

class Cus00700CustoRealCoz extends \Zeedhi\Framework\Controller\Report {

    protected $qr2Strategy;
    protected $reportName;
    protected $nrorg;
    protected $nrlista;
    protected $pla08200Service;

    public function __construct(ReportService $reportService, $qr2Strategy, $pla08200Service, $requisicaoPlanejamentoProducaoService) {
        $this->qr2Strategy = $qr2Strategy;
        $this->pla08200Service = $pla08200Service;
        $this->requisicaoPlanejamentoProducaoService = $requisicaoPlanejamentoProducaoService;

        parent::__construct($reportService);
    }

    protected $reportMapping = array (
        'mCUS00700' =>
            array (
                'strategy' => 'QR2',
                'parameterMapping' =>
                    array (
                        'CDCENTRAL' => 'P_CDCENTRAL',
                        'NMCENTRAL' => 'P_NMCENTRAL',
                        'NRLISTASERVICO' => 'P_NRLISTASERV',
                        'NRORG' => 'P_NRORG',
                        'DTINICIAL' => 'P_DATAINIC',
                        'DTFINAL' => 'P_DATAFINA',
                        'NMTIPOCUSTO' => 'P_NMCUSTO',
                        'DTPERIINIC' => 'P_DTPERIINIC',
                        'DTPERIFINA' => 'P_DTPERIFINA',
                        'IDESTOCAVEIS' => 'P_IDESTOCAVEIS',
                        'IDNAOESTOC' => 'P_IDNAOESTOC',
                        'CDTIPOCUSTO' => 'P_NRTIPOCUSTO',
                        'TIPONIVEL' => 'P_NRTAMACNIVEL',
                        'NRTAMCODIGO' => 'P_NRTAMCODIGO',
                        'DTMESINIC' => 'P_DTMESINIC',
                        'DTMESFINA' => 'P_DTMESFINA',
                        'IDQUEBRAPAGINA' => 'P_IDQUEBRAPAGINA',
                        'ORDENA' => 'P_ORDENA'
                    )
            ),
        'mCUS00701' =>
            array (
                'strategy' => 'QR2',
                'parameterMapping' =>
                    array (
                        'CDCENTRAL' => 'P_CDCENTRAL',
                        'NMCENTRAL' => 'P_NMCENTRAL',
                        'NRLISTASERVICO' => 'P_NRLISTASERV',
                        'DTINICIAL' => 'P_DATAINIC',
                        'DTFINAL' => 'P_DATAFINA',
                        'NRORG' => 'P_NRORG',
                        'NMTIPOCUSTO' => 'P_NMCUSTO',
                        'DTPERIINIC' => 'P_DTPERIINIC',
                        'DTPERIFINA' => 'P_DTPERIFINA',
                        'IDESTOCAVEIS' => 'P_IDESTOCAVEIS',
                        'IDNAOESTOC' => 'P_IDNAOESTOC',
                        'CDTIPOCUSTO' => 'P_NRTIPOCUSTO',
                        'TIPONIVEL' => 'P_NRTAMACNIVEL',
                        'NRTAMCODIGO' => 'P_NRTAMCODIGO',
                        'DTMESINIC' => 'P_DTMESINIC',
                        'DTMESFINA' => 'P_DTMESFINA',
                        'IDQUEBRAPAGINA' => 'P_IDQUEBRAPAGINA',
                        'ORDENA' => 'P_ORDENA'
                    )
            ),
        'mCUS00702' =>
            array (
                'strategy' => 'QR2',
                'parameterMapping' =>
                    array (
                        'CDCENTRAL' => 'P_CDCENTRAL',
                        'NMCENTRAL' => 'P_NMCENTRAL',
                        'NRLISTASERVICO' => 'P_NRLISTASERV',
                        'NRORG' => 'P_NRORG',
                        'DTINICIAL' => 'P_DATAINIC',
                        'DTFINAL' => 'P_DATAFINA',
                        'DTPERIINIC' => 'P_DTPERIINIC',
                        'DTPERIFINA' => 'P_DTPERIFINA',
                        'CDTIPOCUSTO' => 'P_NRTIPOCUSTO',
                        'NMTIPOCUSTO' => 'P_NMCUSTO',
                        'IDESTOCAVEIS' => 'P_IDESTOCAVEIS',
                        'IDNAOESTOC' => 'P_IDNAOESTOC',
                        'DTMESINIC' => 'P_DTMESINIC',
                        'DTMESFINA' => 'P_DTMESFINA',
                        'IDQUEBRAPAGINA' => 'P_IDQUEBRAPAGINA'
                    )
            ),
        'mCUS00703' =>
            array (
                'strategy' => 'QR2',
                'parameterMapping' =>
                    array (
                        'CDCENTRAL' => 'P_CDCENTRAL',
                        'NMCENTRAL' => 'P_NMCENTRAL',
                        'NRLISTASERVICO' => 'P_NRLISTASERV',
                        'NRORG' => 'P_NRORG',
                        'DTINICIAL' => 'P_DATAINIC',
                        'DTFINAL' => 'P_DATAFINA',
                        'DTPERIINIC' => 'P_DTPERIINIC',
                        'DTPERIFINA' => 'P_DTPERIFINA',
                        'CDTIPOCUSTO' => 'P_NRTIPOCUSTO',
                        'NMTIPOCUSTO' => 'P_NMCUSTO',
                        'IDESTOCAVEIS' => 'P_IDESTOCAVEIS',
                        'IDNAOESTOC' => 'P_IDNAOESTOC',
                        'DTMESINIC' => 'P_DTMESINIC',
                        'DTMESFINA' => 'P_DTMESFINA',
                        'IDQUEBRAPAGINA' => 'P_IDQUEBRAPAGINA'
                    )
            ),
        'mCUS00704' =>
            array (
                'strategy' => 'QR2',
                'parameterMapping' =>
                    array (
                        'CDCENTRAL' => 'P_CDCENTRAL',
                        'NMCENTRAL' => 'P_NMCENTRAL',
                        'NRLISTASERVICO' => 'P_NRLISTASERV',
                        'DTINICIAL' => 'P_DATAINIC',
                        'DTFINAL' => 'P_DATAFINA',
                        'NRORG' => 'P_NRORG',
                        'NMTIPOCUSTO' => 'P_NMCUSTO',
                        'DTPERIINIC' => 'P_DTPERIINIC',
                        'DTPERIFINA' => 'P_DTPERIFINA',
                        'IDESTOCAVEIS' => 'P_IDESTOCAVEIS',
                        'IDNAOESTOC' => 'P_IDNAOESTOC',
                        'CDTIPOCUSTO' => 'P_NRTIPOCUSTO',
                        'TIPONIVEL' => 'P_NRTAMACNIVEL',
                        'NRTAMCODIGO' => 'P_NRTAMCODIGO',
                        'DTMESINIC' => 'P_DTMESINIC',
                        'DTMESFINA' => 'P_DTMESFINA',
                        'IDQUEBRAPAGINA' => 'P_IDQUEBRAPAGINA'
                    )
            )
    );


    public function beforeProcessReport(DTO\Request\Row $request, DTO\Response $response) {
        $row = $request->getRow();
        $this->qr2Strategy->setQr2Type($row['QR2TYPE']);
        $this->reportName = $row['CD_REPORT_NAME'];
        $this->nrorg = $row['NRORG'];
        
        $row['CDGRUPFILI']    = $row['CDGRUPFILI'] == '' ? 'T' : $row['CDGRUPFILI'];
        $row["LISTAFILIAL"]   = $this->pla08200Service->retornaFiliais((array)$row);
        $row["LISTAGRUPSERV"] = $this->pla08200Service->retornaGrupServ((array)$row);
        $row['LISTASERVICO']  = $this->pla08200Service->retornaServico((array)$row);

        $this->nrlista = $this->requisicaoPlanejamentoProducaoService->geraLista($this->nrorg, $row["LISTASERVICO"], '_');
        $row['NRLISTASERVICO'] = $this->nrlista;

        $row['DTPERIINIC']  = $row['DTMESINIC'] = $row['DTINICIAL'];
        $row['DTPERIFINA']  = $row['DTMESFINA'] = $row['DTFINAL'];
        $row['NRTAMCODIGO'] = $row['TIPONIVEL'];
    }
    

    public function afterProcessReport(DTO\Request\Row $request, DTO\Response $response, $report) {
        $this->requisicaoPlanejamentoProducaoService->deletaLista($this->nrorg, $this->nrlista);
    }
}